'Arithmetic-Expression Evaluator (includes integer divide)
'Jan. 23, 2001

'This parser is one of the modules of Calculait 3.0, a full-featured
'scientific calculator with a world clock. It is available
'for downloading from ZDNet, Nonags and other freeware sites.
'This updated version includes a routine to handle results in 
'scientific format.

DECLARE SUB EvaluateArith
DECLARE SUB CheckE(newstring$ AS STRING)

DIM formula$ AS STRING

DO
  CLS
  PRINT "This is the engine for an arithmetic-expression evaluator."
  PRINT "It doesn't use the stack as the sample evaluate.bas does"
  PRINT "and, hence, is easier to read. It can correctly evaluate"
  PRINT "  an expression such as -(-5)+(-4)-(-3)+(2)-(1), which"
  PRINT "               evaluate.bas can't do."
  PRINT
  PRINT "        You can do as you please with this code."
  PRINT "                  By Achilles Mina"
  PRINT 
  INPUT formula$
  'formula$ = "2^(1 - (2^2)/2 * (1 + ((2 ^ 2) + 1)) + 1)"
  'formula$ = "(1 + 2+3+4+5+6+7+8+9+10-55)"
  'formula$ = "3+(4*(-3+2*34)+2)^2"
  'formula$ = "-5-4-3-2-1" 
  'formula$ = "(-2)^2 +1"
  'formula$ = "-(-5)+(-4)-(-3)+(2)-(1) + (.5 + 1)^2"
  EvaluateArith
LOOP UNTIL a = 30

SUB EvaluateArith
  DEFDBL answer
  formula$ = LCASE$(REPLACESUBSTR$(formula$," ",""))
  FOR i = 1 TO 1000
    DO
      reformatted = 0
      formulaL = LEN(formula$)
      par1 = RINSTR(formulaL,formula$,"(")
      par2 = INSTR(par1,formula$,")")
      IF par1 = 0 OR par2 = 0 THEN
        betweenpars$ = formula$
      ELSE
        betweenpars$ = MID$(formula$,par1+1,(par2-1)-par1)
      END IF
      IF INSTR(betweenpars$,"^") <> 0 THEN
        pivotoperator$ = "^"
        operator = INSTR(betweenpars$,"^")      
      ELSEIF INSTR(betweenpars$,"*") <> 0 THEN
        pivotoperator$ = "*"
        operator = INSTR(betweenpars$,"*")
      ELSEIF INSTR(betweenpars$,"/") <> 0 THEN
        pivotoperator$ = "/"
        operator = INSTR(betweenpars$,"/")
      ELSEIF INSTR(betweenpars$,"\") <> 0 THEN
        pivotoperator$ = "\"
        operator = INSTR(betweenpars$,"\")
      ELSEIF INSTR(betweenpars$,"+") <> 0 OR INSTR(betweenpars$,"-") <> 0 THEN
        IF MID$(betweenpars$,1,1) = "-" THEN 
          start = 2
        ELSE
          start = 1
        END IF      
        IF (TALLY(betweenpars$,"-") = 1 AND TALLY(betweenpars$,"+") = 0) AND MID$(betweenpars$,1,1) = "-" THEN
          formula$ = DELETE$(formula$,par1,1)
          formula$ = DELETE$(formula$,par2-1,1)
          IF formula$ = betweenpars$ THEN
            print
            answer = VAL(formula$) 
            IF answer < .000000000000001 THEN
              formula$ = FORMAT$("%g",answer)
            END IF
            print formula$
            input "Type 30 to quit, else Enter ",a
            EXIT SUB
          END IF
          reformatted = 1
        ELSE
          FOR y = start TO LEN(betweenpars$)
            operator$ = MID$(betweenpars$,y,1)
            SELECT CASE operator$
              CASE "+","-"
                operator = y
                pivotoperator$ = MID$(betweenpars$,operator,1)
                EXIT FOR
            END SELECT
          NEXT
        END IF
      ELSE
        formula$ = DELETE$(formula$,par1,1)
        formula$ = DELETE$(formula$,par2-1,1) 
        IF formula$ = betweenpars$ THEN
          print
          answer = VAL(formula$) 
          IF answer < .000000000000001 THEN
            formula$ = FORMAT$("%g",answer)
          END IF
          print formula$
          input "Type 30 to quit, else Enter ",a 
          EXIT SUB
        END IF
        reformatted = 1
      END IF
      formula$ = REPLACESUBSTR$(formula$,"--","+")
    LOOP UNTIL reformatted = 0
    x = operator
    DO
      INC x
      IF x >= LEN(betweenpars$) THEN
        postoperator = x
        EXIT DO
      END IF  
      operator$ = MID$(betweenpars$,x,1)
      SELECT CASE operator$
        CASE "+","-","*","/","\"
          postoperator = x - 1
          EXIT DO
      END SELECT
    LOOP
    x = operator
    DO
      DEC x
      IF x <= 1 THEN
        preoperator = 1
        EXIT DO
      END IF
      operator$ = MID$(betweenpars$,x,1)
      SELECT CASE operator$
        CASE "+","-","*","/","\"
          IF operator$ = "-" THEN
            IF pivotoperator$ = "*" OR pivotoperator$ = "/"  OR pivotoperator$ = "\" THEN 
              preoperator = x
            ELSE
              preoperator = x + 1
            END IF
          ELSE
            preoperator = x + 1
          END IF
          EXIT DO
      END SELECT
    LOOP
    preopnumber = VAL(MID$(betweenpars$,preoperator,(operator-1)-(preoperator-1)))
    postopnumber = VAL(MID$(betweenpars$,operator+1,postoperator-operator))
    oldstring$ = MID$(formula$,par1+preoperator,postoperator-(preoperator-1))
    SELECT CASE pivotoperator$
      CASE "^"
        newstring$ = STR$(preopnumber ^ postopnumber)
      CASE "*"
        newstring$ = STR$(preopnumber * postopnumber)
      CASE "/"
        newstring$ = STR$(preopnumber / postopnumber)
      CASE "\"
        newstring$ = STR$(preopnumber \ postopnumber)
      CASE "+"
        newstring$ = STR$(preopnumber + postopnumber)
      CASE "-"
        newstring$ = STR$(preopnumber - postopnumber)
    END SELECT
    CheckE(@newstring$)
    formula$ = REPLACESUBSTR$(formula$,oldstring$,newstring$)
    print formula$
  NEXT
END SUB

SUB CheckE(newstring$ AS STRING)
  DEFBYTE whereE, x, move
  whereE = INSTR(newstring$,"E")
  x = whereE
  IF whereE = 0 THEN
    EXIT SUB
  ELSE
    whereDot = RINSTR(whereE,newstring$,".")
    IF whereDot < 2 THEN whereDot = 2      'since scientific format
    DO
      INC x
      IF x >= LEN(newstring$) THEN
        powerEnd = x
        EXIT DO
      END IF  
      powerEnd$ = MID$(newstring$,x,1)
      SELECT CASE powerEnd$
        CASE "+","*","/","\"
          powerEnd = x - 1
          EXIT DO
        CASE "-"
          IF x <> whereE + 1 THEN
            powerEnd = x - 1
            EXIT DO
          END IF
      END SELECT
    LOOP
    oldbase$ = LEFT$(newstring$,whereE-1)
    base$ = REPLACESUBSTR$(oldbase$,".","")
    power$ = MID$(newstring$,whereE+1,powerEnd-whereE)
    checkneg$ = LEFT$(power$,1)
    IF checkneg$ = "-" THEN
      move = ABS(VAL(power$))
      newbase$ = "." + STRING$(move-(whereDot-1),"0") + base$
    END IF
    newstring$ = newbase$
  END IF
END SUB