'Math-Expression Evaluator
'Updated: Jan. 23, 2001
'This parser is one of the modules of Calculait 3.0, a full-featured
'scientific calculator with a world clock. It is available
'for downloading from ZDNet, Nonags other freeware sites.

'This update includes abs() int() frac() ceil() and floor(). Also, 2 routines have been added: one to 
'handle internal values in scientific notation; the other to check syntax. 

DECLARE SUB Functions(par1 AS INTEGER, mathval$ AS STRING)
DECLARE SUB ExpSolverEdit
DECLARE SUB CheckE(newstring$ AS STRING)
DECLARE SUB CheckSyntax

DIM formula$ AS STRING
DEFDBL CModeN, CMode 
DIM Math(1 TO 34) AS STRING
  Math(1) = "sin"
  Math(2) = "cos"
  Math(3) = "tan"
  Math(4) = "cot"
  Math(5) = "sec"
  Math(6) = "csc"
  Math(7) = "sqrt"
  Math(8) = "log"
  Math(9) = "ln"
  Math(10) = "asin"
  Math(11) = "acos"
  Math(12) = "atan"
  Math(13) = "acot"
  Math(14) = "asec"
  Math(15) = "acsc"
  Math(16) = "sinh"
  Math(17) = "cosh"
  Math(18) = "tanh"
  Math(19) = "coth"
  Math(20) = "sech"
  Math(21) = "csch"
  Math(22) = "asinh"
  Math(23) = "acosh"
  Math(24) = "atanh"
  Math(25) = "acoth"
  Math(26) = "asech"
  Math(27) = "acsch"
  Math(28) = "inv"
  Math(29) = "exp"
  Math(30) = "abs"
  Math(31) = "int"
  Math(32) = "frac"
  Math(33) = "floor"
  Math(34) = "ceil"
  CMode = 1                    'radians
  CModeN = 1                   'radians
  CMode = 57.2957795130824    degrees
  CModeN = 0.0174532925199433 degrees
DO
  CLS
  PRINT "This is the engine for an expression evaluator."
  PRINT " All the trigonometric, inverse trigonometric,"
  PRINT "hyperbolic, inverse hyperbolic and logarithmic"
  PRINT " functions are supported, plus integer divide"
  PRINT "         and the inverse operator."
  PRINT
  PRINT "   You can do as you please with this code."
  PRINT "             By Achilles Mina"
  PRINT 
  INPUT formula$
  'formula$ = "2^(1 - (2^2)/2 * (1 + ((2 ^ 2) + 1)) + 1)"
  'formula$ = "(1 + 2+3+4+5+6+7+8+9+10-55)"
  'formula$ = "3+(4*(-3+2*34)+2)^2"
  'formula$ = "-5-4-3-2-1" 
  'formula$ = "(-2)^2 +1"
  'formula$ = "-(-5)+(-4)-(-3)+(2)-(1) + (.5 + 1)^2"
  'formula$ = "Sin(.1)^2-3*Ln(Tan(.1*PI))"
  'formula$ = "Sin(.1)-3*Ln(Tam(.1*PI))"
  'formula$ = "Ln(Tan(.1*PI))"
  IF formula$ <> "" THEN CheckSyntax
LOOP UNTIL a = 30

SUB CheckSyntax
DEFSHORT posops, startmath
  formula$ = LCASE$(REPLACESUBSTR$(formula$," ",""))
    math$ = ""
    startmath = 0
    errmath$ = ""
    formula$ = REPLACESUBSTR$(formula$,"pi","3.14159265358979")
    IF TALLY(formula$,"(") <> TALLY(formula$,")") THEN
      MessageDlg("Missing parenthesis. Please correct syntax.", mtError, mbOK, 0)
      EXIT SUB
    ELSEIF TALLY(formula$,"(") = 0 OR TALLY(formula$,")") = 0 THEN
      IF VAL(formula$ + "1") = 0 THEN
        MessageDlg("Invalid expression. Please correct syntax.", mtError, mbOK, 0)
        EXIT SUB
      END IF
    ELSE
      DO        
        INC startmath
        oldmathchar$ = mathchar$
        mathchar$ = MID$(formula$,startmath,1)
        SELECT CASE mathchar$
          CASE "a","b","c","e","f","g","h","i","l","n","o","p","q","r","s","t","v","x"
            math$ = math$ + mathchar$
            errmath$ = math$
          CASE "d","j","k","m","u","w","y","z"
            errmath$ = math$ + mathchar$
            FOR x = 1 TO 6
              ops$ = MID$("+-*/^\",x,1)
              posops = RINSTR(errmath$,ops$)
              IF posops <> 0 THEN EXIT FOR
            NEXT
            errmath$ = RIGHT$(errmath$,LEN(errmath$)-posops)
            MessageDlg(errmath$ + "?" + " Please correct syntax.", mtError, mbOK, 0)
            EXIT SUB
          CASE "("
            IF math$ <> "" THEN
              FOR x = 1 TO 34
                IF math$ = Math(x) THEN 
                  math$ = ""
                END IF
              NEXT
              IF math$ <> "" THEN      'if there's a match, skip this                
                MessageDlg(errmath$ + "?" + " Please correct syntax.", mtError, mbOK, 0)
                EXIT SUB
              END IF
            END IF
          CASE "0","1","2","3","4","5","6","7","8","9"
            errmath$ = math$ + mathchar$
            SELECT CASE oldmathchar$
              CASE "a" TO "z"
                FOR x = 1 TO 6
                  ops$ = MID$("+-*/^\",x,1)
                  posops = RINSTR(errmath$,ops$)
                  IF posops <> 0 THEN EXIT FOR
                NEXT
                errmath$ = RIGHT$(errmath$,LEN(errmath$)-posops)
                MessageDlg(errmath$ + "?" + " Please correct syntax.", mtError, mbOK, 0)
                EXIT SUB
            END SELECT
          CASE "+","-","*","/","\","^"
            IF math$ <> "" AND (INSTR(math$,"(") = 0 OR INSTR(math$,")") = 0) THEN
              FOR x = 1 TO 6
                ops$ = MID$("+-*/^\",x,1)
                posops = RINSTR(errmath$,ops$)
                IF posops <> 0 THEN EXIT FOR
              NEXT
              math$ = RIGHT$(math$,LEN(math$)-posops)
              MessageDlg("Missing parenthesis. Please correct syntax.", mtError, mbOK, 0)
              EXIT SUB
            END IF              
        END SELECT    
      LOOP UNTIL startmath = LEN(formula$)
    END IF
    ExpSolverEdit
END SUB

SUB ExpSolverEdit
  DEFDBL answer
  FOR i = 1 TO 1000
    DO
      reformatted = 0
      formulaL = LEN(formula$)
      par1 = RINSTR(formulaL,formula$,"(")
      par2 = INSTR(par1,formula$,")")
      IF par1 = 0 OR par2 = 0 THEN
        betweenpars$ = formula$
      ELSE
        betweenpars$ = MID$(formula$,par1+1,(par2-1)-par1)
      END IF
      IF INSTR(betweenpars$,"^") <> 0 THEN
        pivotoperator$ = "^"
        operator = INSTR(betweenpars$,"^")      
      ELSEIF INSTR(betweenpars$,"*") <> 0 THEN
        pivotoperator$ = "*"
        operator = INSTR(betweenpars$,"*")
      ELSEIF INSTR(betweenpars$,"/") <> 0 THEN
        pivotoperator$ = "/"
        operator = INSTR(betweenpars$,"/")
      ELSEIF INSTR(betweenpars$,"\") <> 0 THEN
        pivotoperator$ = "\"
        operator = INSTR(betweenpars$,"\")
      ELSEIF (INSTR(betweenpars$,"+") <> 0 OR INSTR(betweenpars$,"-") <> 0) AND INSTR(betweenpars$,"E") = 0 THEN
        IF MID$(betweenpars$,1,1) = "-" THEN 
          start = 2
        ELSE
          start = 1
        END IF
        IF (TALLY(betweenpars$,"-") = 1 AND TALLY(betweenpars$,"+") = 0) AND MID$(betweenpars$,1,1) = "-" THEN
          checkback$ = MID$(formula$,par1-1,1)
          SELECT CASE checkback$
            CASE "c","g","h","l","n","p","r","s","t","v"
              Functions(par1,betweenpars$)
            CASE ELSE
              formula$ = DELETE$(formula$,par1,1)
              formula$ = DELETE$(formula$,par2-1,1) 
          END SELECT
          IF formula$ = betweenpars$ THEN
            IF soundoff = 0 THEN PLAYWAV  "whooh.wav",1
            print
            answer = VAL(formula$) 
            IF answer < .000000000000001 THEN
              formula$ = FORMAT$("%g",answer)
            END IF
            print formula$
            input "Type 30 to quit, else Enter ",a
            EXIT SUB
          END IF
          reformatted = 1
        ELSE
          FOR y = start TO LEN(betweenpars$)
            operator$ = MID$(betweenpars$,y,1)
            SELECT CASE operator$
              CASE "+","-"
                operator = y
                pivotoperator$ = MID$(betweenpars$,operator,1)
                EXIT FOR
            END SELECT
          NEXT
        END IF
      ELSE
        checkback$ = MID$(formula$,par1-1,1)
        SELECT CASE checkback$
          CASE "c","g","h","l","n","p","r","s","t","v"
            Functions(par1,betweenpars$)
          CASE ELSE
            formula$ = DELETE$(formula$,par1,1)
            formula$ = DELETE$(formula$,par2-1,1) 
        END SELECT
        IF formula$ = betweenpars$ THEN
          IF soundoff = 0 THEN PLAYWAV  "whooh.wav",1
          print
          answer = VAL(formula$)
          IF answer < .000000000000001 THEN
            formula$ = FORMAT$("%g",answer)
          END IF
          print formula$
          input "Type 30 to quit, else Enter ",a
          EXIT SUB
        END IF
        reformatted = 1
      END IF
      formula$ = REPLACESUBSTR$(formula$,"--","+")
    LOOP UNTIL reformatted = 0
    x = operator
    DO
      INC x
      IF x >= LEN(betweenpars$) THEN
        postoperator = x
        EXIT DO
      END IF  
      operator$ = MID$(betweenpars$,x,1)
      SELECT CASE operator$
        CASE "+","*","/","\","^"
          postoperator = x - 1
          EXIT DO
        CASE "-"
          IF x <> operator + 1 THEN
            postoperator = x - 1
            EXIT DO
          END IF
      END SELECT
    LOOP
    x = operator
    DO
      DEC x
      IF x <= 1 THEN
       preoperator = 1
       EXIT DO
      END IF
      operator$ = MID$(betweenpars$,x,1)
      SELECT CASE operator$
        CASE "+","-","*","/","\","^"
          preoperator = x + 1
          EXIT DO
      END SELECT
    LOOP
    preopnumber = VAL(MID$(betweenpars$,preoperator,(operator-1)-(preoperator-1)))
    postopnumber = VAL(MID$(betweenpars$,operator+1,postoperator-operator))
    oldstring$ = MID$(formula$,par1+preoperator,postoperator-(preoperator-1))
    SELECT CASE pivotoperator$
      CASE "^"
        newstring = preopnumber ^ postopnumber
      CASE "*"
        newstring = preopnumber * postopnumber
      CASE "/"
        newstring = preopnumber / postopnumber
      CASE "+"
        newstring = preopnumber + postopnumber
      CASE "-"
        newstring = preopnumber - postopnumber
      CASE "\"
        newstring = preopnumber \ postopnumber             
    END SELECT
    newstring$ = STR$(newstring)
    CheckE(@newstring$)
    formula$ = REPLACESUBSTR$(formula$,oldstring$,newstring$)
  NEXT
END SUB

SUB Functions(par1 AS INTEGER,mathval$ AS STRING)
  startmath = par1
  DO        
    DEC startmath
    mathchar$ = MID$(formula$,startmath,1)
    SELECT CASE mathchar$
      CASE "+","-","*","/","^","\","("
        EXIT DO
      CASE "a","b","c","e","f","g","h","i","l","n","o","p","q","r","s","t","v","x"
        math$ = mathchar$ + math$
    END SELECT        
  LOOP UNTIL startmath <= 1
  FOR i = 1 TO 34
    IF math$ = Math(i) THEN
      math$ = ""
      oldval$ = Math(i) + "(" + mathval$ + ")"
      SELECT CASE i
        CASE 1
          insertval = SIN(VAL(mathval$)*CModeN)
        CASE 2
          insertval = COS(VAL(mathval$)*CModeN)
        CASE 3
          insertval = TAN(VAL(mathval$)*CModeN)
        CASE 4
          insertval = 1/(TAN(VAL(mathval$)*CModeN))
        CASE 5
          insertval = 1/(COS(VAL(mathval$)*CModeN))
        CASE 6
          insertval = 1/(SIN(VAL(mathval$)*CModeN))
        CASE 7
          insertval = SQR(VAL(mathval$))
        CASE 8
          insertval = LOG(VAL(mathval$))/LOG(10)
        CASE 9
          insertval = LOG(VAL(mathval$))
        CASE 10
          insertval = ATN(VAL(mathval$)/SQR(-VAL(mathval$)*VAL(mathval$) +1))*CMode
        CASE 11
          insertval = (-ATN(VAL(mathval$)/SQR(-VAL(mathval$)*VAL(mathval$) +1)) + 1.570796)*CMode
        CASE 12
          insertval = (ATN(VAL(mathval$)) + 1.570796)*CMode
        CASE 13
          insertval = (-ATN(VAL(mathval$)) + 1.570796)*CMode
        CASE 14
          insertval = (ATN(SQR(VAL(mathval$)*VAL(mathval$) -1)) + (SGN(VAL(mathval$)) -1)*1.570796)*CMode
        CASE 15
          insertval = (ATN(1/SQR(VAL(mathval$)*VAL(mathval$) -1)) + (SGN(VAL(mathval$)) -1)*1.570796)*CMode
        CASE 16
          insertval = (EXP(VAL(mathval$)) - EXP(-VAL(mathval$)))/2
        CASE 17
          insertval = (EXP(VAL(mathval$)) + EXP(-VAL(mathval$)))/2
        CASE 18
          insertval = -EXP(-VAL(mathval$)) /(EXP(VAL(mathval$)) + EXP(-VAL(mathval$)))*2 + 1
        CASE 19
          insertval = EXP(-VAL(mathval$))/(EXP(VAL(mathval$)) - EXP(-VAL(mathval$)))*2 + 1
        CASE 20
          insertval = 2/(EXP(VAL(mathval$)) + EXP(-VAL(mathval$)))
        CASE 21
          insertval = 2/(EXP(VAL(mathval$)) - EXP(-VAL(mathval$)))
        CASE 22
          insertval = LOG(VAL(mathval$) + SQR(VAL(mathval$)*VAL(mathval$) + 1))
        CASE 23
          insertval = LOG(VAL(mathval$) + SQR(VAL(mathval$)*VAL(mathval$) - 1))
        CASE 24
          insertval = LOG((1 + VAL(mathval$))/(1 - VAL(mathval$)))/2
        CASE 25
          insertval = LOG((VAL(mathval$) + 1)/(VAL(mathval$) - 1))/2
        CASE 26
          insertval = LOG((SGN(VAL(mathval$))*SQR(-VAL(mathval$)*VAL(mathval$) + 1) + 1)/VAL(mathval$))
        CASE 27
          insertval = LOG((SGN(VAL(mathval$))*SQR(VAL(mathval$)*VAL(mathval$) + 1) + 1)/VAL(mathval$))
        CASE 28
          insertval = 1/VAL(mathval$)
        CASE 29
          insertval = EXP(VAL(mathval$))
        CASE 30
          insertval = ABS(VAL(mathval$))
        CASE 31
          insertval = INT(VAL(mathval$))
        CASE 32
          insertval = FRAC(VAL(mathval$))
        CASE 33
          insertval = FLOOR(VAL(mathval$))
        CASE 34
          insertval = CEIL(VAL(mathval$))
      END SELECT
    END IF
  NEXT
  insertval$ = STR$(insertval)
  CheckE(@insertval$)
  formula$ = REPLACESUBSTR$(formula$,oldval$,insertval$)
END SUB

SUB CheckE(newstring$ AS STRING)
  DEFBYTE whereE, x, move
  whereE = INSTR(newstring$,"E")
  x = whereE
  IF whereE = 0 THEN
    EXIT SUB
  ELSE
    whereDot = RINSTR(whereE,newstring$,".")
    IF whereDot < 2 THEN whereDot = 2      'since in scientific format
    DO
      INC x
      IF x >= LEN(newstring$) THEN
        powerEnd = x
        EXIT DO
      END IF  
      powerEnd$ = MID$(newstring$,x,1)
      SELECT CASE powerEnd$
        CASE "+","*","/","\"
          powerEnd = x - 1
          EXIT DO
        CASE "-"
          IF x <> whereE + 1 THEN
            powerEnd = x - 1
            EXIT DO
          END IF
      END SELECT
    LOOP
    oldbase$ = LEFT$(newstring$,whereE-1)
    base$ = REPLACESUBSTR$(oldbase$,".","")
    power$ = MID$(newstring$,whereE+1,powerEnd-whereE)
    checkneg$ = LEFT$(power$,1)
    IF checkneg$ = "-" THEN
      move = ABS(VAL(power$))
      newbase$ = "." + STRING$(move-(whereDot-1),"0") + base$
    END IF
    newstring$ = newbase$
  END IF
END SUB