' Bill K 12-2002  FlyingPanels.rqb
' This demonstrates how to make controls sizeable
' and how to drag them.  All very easy made
' possible by a couple nice API functions.
' This also shows a caption bar added to a QPanel
' and all panels are captive (MDI-like) to the
' Main Form.  Enjoy!
     $OPTIMIZE ON
     $APPTYPE GUI
     $TYPECHECK ON
     CONST CRLF=CHR$(13) & CHR$(10)
     DEFSTR RTEXT
     RTEXT="This is a QPanel with a caption bar" & CRLF
     RTEXT=RTEXT & "and a QRichEdit.  It is sizeable _
and can" & CRLF
     RTEXT=RTEXT & "be dragged by the caption bar. _
It is" & CRLF
     RTEXT=RTEXT & "a captive child to a panel in the Main _
Form." & CRLF
     RTEXT=RTEXT & " " & CRLF
     RTEXT=RTEXT & "The two top panels are QPanels that _
are" & CRLF
     RTEXT=RTEXT & "sizeable and can be dragged and" _
      & CRLF
     RTEXT=RTEXT & "are captive to the Main Form." _
      & CRLF
     RTEXT=RTEXT & "" & CRLF
     RTEXT=RTEXT & "QPanel2 has a QEdit textbox that " _
      & CRLF
     RTEXT=RTEXT & "was made sizeable." & CRLF
     RTEXT=RTEXT & "" & CRLF
     RTEXT=RTEXT & "Each panel will re-dock at the _
top" & CRLF
     RTEXT=RTEXT & "of the Main Form when double-_
clicked." & CRLF
     RTEXT=RTEXT & "" & CRLF
     RTEXT=RTEXT & "Enjoy. " & CRLF
     RTEXT=RTEXT & "" & CRLF
     RTEXT=RTEXT & "Bill K" & CRLF

'DECLARE CONSTANTS=================
     CONST GWL_STYLE AS LONG = (-16)
     CONST WS_THICKFRAME AS LONG = &H40000
     CONST SWP_DRAWFRAME AS LONG = &H20
     CONST SWP_NOMOVE AS LONG = &H2
     CONST SWP_NOSIZE AS LONG = &H1
     CONST SWP_NOZORDER AS LONG = &H4
     CONST SWP_FLAGS AS LONG = SWP_NOZORDER OR _
      SWP_NOSIZE OR _
      SWP_NOMOVE OR SWP_DRAWFRAME
     CONST WS_CAPTION AS LONG = &HC00000
     CONST COLOR_ACTIVECAPTION = 2
'DECLARE VARIABLES===================
     DEFSTR CURSPRV
     DEFLNG style
'DECLARE SUBS=======================
     DECLARE SUB DOINIT
     DECLARE SUB DORESIZE
     DECLARE SUB SetPanelStyle(Style, PN AS QPANEL)
     DECLARE SUB SetEditStyle(Style, ED AS QEDIT)
     DECLARE SUB MOVEPANEL(BUTTON AS INTEGER, _
      SHIFT AS INTEGER, X AS SINGLE, Y AS SINGLE, _
      PN AS QPANEL)
     DECLARE SUB ALIGNPANEL(PN AS QPANEL)

'DECLARE FUNCTIONS==================
     DECLARE FUNCTION SetWindowLong LIB "User32" ALIAS_
      "SetWindowLongA" (hwnd AS LONG, nIndex _
      AS LONG, dwNewLong AS LONG) AS LONG
     DECLARE FUNCTION SetWindowPos LIB "user32" ALIAS_
      "SetWindowPos"(hWnd AS LONG, hWndAfter AS LONG, _
      x AS INTEGER, y AS INTEGER, width AS INTEGER, _
      height AS INTEGER, FLAGS AS INTEGER) AS INTEGER
     DECLARE FUNCTION ReleaseCapture LIB "user32" _
      ALIAS "ReleaseCapture" () AS LONG
     DECLARE FUNCTION GetWindowLong LIB "user32" _
      ALIAS "GetWindowLongA"(ByVal hwnd AS LONG,ByVal _
      nIndex AS LONG) AS LONG
     DECLARE FUNCTION GetSysColor LIB "user32" _
      ALIAS "GetSysColor" (nIndex AS LONG) AS LONG
     DECLARE FUNCTION FlashWindow LIB "user32" _
      ALIAS "FlashWindow" (ByVal hwnd AS LONG, ByVal _
      bInvert AS LONG) AS LONG
'===========
     CREATE BFONT AS QFONT
      NAME="ARIAL"
      SIZE=10
      BOLD=1
     END CREATE
'{===========FORMS================
     CREATE FORM AS QFORM '
      CAPTION="MAIN FORM"
      ONSHOW =DOINIT
      AUTOSCROLL=0
      Width = 490
      Height = 520
      Center
      CREATE Panel1 AS QPANEL
       CAPTION="Sizeable Flying QPanel1"
       TAG=1
       ONMOUSEDOWN=MOVEPANEL
       FONT=BFONT
       Left = 0
       Top = 0
       OnDblClick=ALIGNPANEL
       Width = FORM.CLIENTWIDTH/2
       Height = 32
       BevelOuter = 0
      END CREATE 'PANEL
      CREATE Panel2 AS QPANEL
       FONT=BFONT
       TAG=2
       CAPTION="Sizeable Flying QPanel2"
       ONMOUSEDOWN=MOVEPANEL
       Left = Panel1.Width
       Top = Panel1.Top
       OnDblClick=ALIGNPANEL
       Width = FORM.CLIENTWIDTH-Panel1.Width
       Height = 32
       BevelOuter = 0
       CREATE SizeEdit AS QEDIT
        top=2
        left=5
        width=30
        height=panel2.height-2-2
        text="Sizeable QEdit"
       END CREATE
      END CREATE 'PANEL
      CREATE MAINPANEL AS QPANEL
       BevelOuter = 1
       Left = 0
       Top = 32
       Width = FORM.CLIENTWIDTH
       Height = FORM.CLIENTHEIGHT - 32
       CREATE Panel3 AS QPANEL
        height=mainpanel.height
        width=mainpanel.width
        CAPTION="Sizeable QPanel with _
          Caption Bar and QRichEdit"
        FONT=BFONT
        TAG=3
        BevelOuter = 0
        CREATE REdit AS QRICHEDIT
         ALIGN=5
         FONT=BFONT
         HideSelection = 0
         PlainText = 1
         ScrollBars = 3
         WantTabs = 1
         TabOrder = 0
        END CREATE
       END CREATE 'PANEL3
      END CREATE 'MAINPANEL AS QPANEL
     END CREATE  ' FORM
'{==================SUBROUTINES======
     SUB DOINIT
   '	SHOWDBUG
      FORM.ONRESIZE=DORESIZE
      style = GetWindowLong(panel1.handle, GWL_STYLE)
      style = style OR WS_THICKFRAME
      SetpanelStyle style, panel1
      style = GetWindowLong(panel2.handle, GWL_STYLE)
      style = style OR WS_THICKFRAME
      SetpanelStyle style, panel2
      style = GetWindowLong(SizeEdit.handle, GWL_STYLE)
      style = style OR WS_THICKFRAME
      SetEditStyle style, SizeEdit
      style = GetWindowLong(panel3.handle, GWL_STYLE)
      style = style OR WS_THICKFRAME OR WS_CAPTION
      SetpanelStyle style, panel3
      FLASHWINDOW panel3.HANDLE, 1
      REDIT.TEXT=RTEXT
     END SUB
     SUB DORESIZE
      MAINPANEL.Left = 0
      MAINPANEL.Top = 32
      MAINPANEL.Width = FORM.CLIENTWIDTH
      MAINPANEL.Height = FORM.CLIENTHEIGHT - 32
     END SUB
     SUB ALIGNPANEL(PN)
      DEFINT TG
      TG=PN.TAG
      IF TG=1 THEN
       PANEL1.TOP=0
       PANEL1.Left =0
       PANEL1.Width = FORM.CLIENTWIDTH/2
       PANEL1.Height =32
      ELSE
       PANEL2.TOP=0
       PANEL2.Left =  FORM.CLIENTWIDTH/2
       PANEL2.Width =  FORM.CLIENTWIDTH/2
       PANEL2.Height =32
       SizeEdit.top=2
       SizeEdit.left=5
       SizeEdit.width=30
       SizeEdit.height=panel2.height-6
      END IF
     END SUB
     SUB SetpanelStyle(style, pn)
      IF style THEN
       SetWindowLong(pn.handle, GWL_STYLE, style)
       SetWindowPos(pn.handle, Form.handle, _
        0, 0, 0, 0, SWP_FLAGS)
      END IF
     END SUB
     SUB SetEditStyle(style, ed)
      IF style THEN
       SetWindowLong(ed.handle, GWL_STYLE, style)
       SetWindowPos(ed.handle, Form.handle, _
        0, 0, 0, 0, SWP_FLAGS)
      END IF
     END SUB
     SUB MOVEPANEL(BUTTON, SHIFT , X , Y ,PN)
      RELEASECAPTURE
      SENDMESSAGE PN.HANDLE, &H112, &HF012, 0
     END SUB
'{===================INITIALIZE CODE====
'========================================
'------- SO MAIN FORM MINIMIZES CORRECTLY--------
     SetWindowLong FORM.HANDLE, -8, 0
     SetWindowLong application.HANDLE, -8, FORM.HANDLE
'----------------
     FORM.SHOWMODAL
