' SiSi-  Simple Simplex - Modul in Rapid-Q
            'Version 17.09.2000
' ------------------------------------------
' Program using the Simplex-Method 
' to solve a linear optimization problem
' written by Bruno Schfer <bup.schaefer@planet-interkom.de> 
$APPTYPE CONSOLE
$INCLUDE "RAPIDQ.INC"
$TYPECHECK ON
COLOR 0,3
SETCONSOLETITLE "Simple SIMPLEX Solver"
'all parameters and values are now in one matrix !!!
'=============to write the values and parameters in the following matrix is your part====================================================================
DIM SiMatrx(50,50)AS DOUBLE  ' !!! if you have more than 50 rows or columns you should change this values
'######The following  matrix " SiMatrx()" is an example  !! ###############################################################################
SiMatrx (1,1) = 4    'number of constraints
SiMatrx (1,2) = 5    'number of variables 
SiMatrx (1,3) = 0    'number of less than
SiMatrx (1,4) = 4    'number of equal
SiMatrx (1,5) = 0    'number of greater than
SiMatrx (1,6) = 0
SiMatrx (2,1) = 1
SiMatrx (2,2) = 1
SiMatrx (2,3) = 1
SiMatrx (2,4) = 1
SiMatrx (2,5) = 1
SiMatrx (2,6) = 100
SiMatrx (3,1) = .9
SiMatrx (3,2) = .8
SiMatrx (3,3) = .95
SiMatrx (3,4) = .7
SiMatrx (3,5) = .3
SiMatrx (3,6) = 83
SiMatrx (4,1) = .05
SiMatrx (4,2) = .05
SiMatrx (4,3) = .02
SiMatrx (4,4) = .3
SiMatrx (4,5) = .7
SiMatrx (4,6) = 14
SiMatrx (5,1) = .05
SiMatrx (5,2) = .15
SiMatrx (5,3) = .03
SiMatrx (5,4) = 0
SiMatrx (5,5) = 0
SiMatrx (5,6) = 3
SiMatrx (6,1) = 6.13
SiMatrx (6,2) = 7.12
SiMatrx (6,3) = 5.85
SiMatrx (6,4) = 4.57
SiMatrx (6,5) = 3.96
SiMatrx (6,6) = -1     'optimization type (-1 or 1)
 ' This is the structure of the SIMPLEX-Matrix :
 '   - compare it to the system of equations of my sample
 '   - in the row number 1 there are the parameters 
 
'| 4     5      0    4    0     0   | number of constraints, variables, less than, equal, greater, rest is zero
'| 1     1     1     1    1    100  |'constants of of the constraints + coeff. of obj. function
'|.9    .8    .95   .7    .3    83  |'coefficient data in the same order + coeff. of obj. function
'|.05   .05   .02   .3    .7    14  |      ' dto.
'|.05   .15   .03    0    0     3   |      ' dto
'|6.13 7.12  5.85  4.57  3.96   -1  |'constraint data + optimization type (-1 for Min. or 1 for Max.)
DECLARE SUB SIMPLEX
DECLARE SUB ParamInput (si_Z,si_M,si_N,si_L,si_E,si_G)
DECLARE SUB leave (si_M, si_A() AS DOUBLE, si_Q, si_R, si_S)
DECLARE SUB pivot (si_A() AS DOUBLE, si_B() AS DOUBLE, si_M2, si_R,si_S,si_C1,si_P) 
DECLARE SUB answers (si_C1,si_C2,si_M,si_B() AS DOUBLE,si_A() AS DOUBLE,si_L,si_Z)
DECLARE SUB BoundCheck (si_Q)
DECLARE SUB Initialization(si_C,si_C1,si_C2,si_M1,si_M2,si_A() AS DOUBLE, si_B() AS DOUBLE)
DECLARE SUB Price (si_S,si_P)
DEFINT si_R, si_C, si_C1 , si_C2, si_M, si_M1 , si_M2, si_M3, si_S, si_Z, si_N, si_L, si_E
DEFINT si_G, si_I, si_I1, si_J, si_J1
DEFDBL si_P, si_Q, si_A(si_M+2,si_N+si_M+si_G+1), si_B(si_M+2)
DIM ENDE$ AS STRING
'=================================================================================
CALL SIMPLEX
'====================here starts the simplex module ================
SUB SIMPLEX
CLS 
PRINT "LINEAR PROGRAMMING"
PRINT
CALL ParamInput (@si_Z,@si_M,@si_N,@si_L,@si_E,@si_G)
IF si_M <> si_L + si_E + si_G THEN 
        PRINT si_M
        showmessage "Data on constraints are inconsistent." + chr$(13) + chr$(13) + "TRY AGAIN !"
        CALL ParamInput (@si_Z,@si_M,@si_N,@si_L,@si_E,@si_G)
END IF     
' REDIMENSION ARRAYS si_A(*,*) & si_B(*)
REDIM si_A(si_M+2,si_N+si_M+si_G+1)AS DOUBLE
REDIM si_B(si_M+2)AS DOUBLE
CALL Initialization(@si_C,@si_C1,@si_C2,@si_M1,@si_M2,si_A(),si_B())
 '-----------------------------DATA - READING--------------------------------
FOR si_I = 1 TO si_M 
     FOR si_J = 1 TO si_N 
         'READ si_A(si_I,si_J)
            si_A(si_I,si_J) = SiMatrx (si_I+1,si_J)
         IF si_I > si_L THEN si_A(si_M1,si_J) = si_A(si_M1,si_J) - si_A(si_I,si_J)
     NEXT si_J 
     IF si_I > si_L THEN 
         si_B(si_I) = si_N + si_G + si_I
         si_A(si_I,si_N+si_G+si_I) = 1
     ELSE
        si_B(si_I) = si_N + si_I
        si_A(si_I,si_N+si_I) = 1 
     END IF   
     IF si_I > si_L + si_E THEN  
         si_A(si_I,si_N+si_I-si_E) = -1
         si_A(si_M1,si_N+si_I-si_E) = 1
     END IF
NEXT si_I
'---------------------------------------
FOR si_I = 1 TO si_M 
    si_A(si_I,si_C1) = SiMatrx (si_I + 1 , si_N + 1)
NEXT si_I
FOR si_J = 1 TO si_N
  si_A (si_M2, si_J) = SiMatrx (Si_M + 2,si_J)
  si_A(si_M2,si_J) = si_Z * si_A(si_M2,si_J)
NEXT si_J
PRINT "Your variables 1 through "; si_N
IF si_L <> 0 THEN PRINT "Slack variables "; si_N + 1;" through "; si_N + si_L 
IF si_G <> 0 THEN PRINT "Surplus variables "; si_N + si_L + 1; " through " ; si_N + si_L
IF si_L <> si_M THEN 
       PRINT "Artificial variables "; si_C2 + 1; " through ";si_C  
          si_M3 = si_M1
  DO 
    si_P = -0.00001
     FOR si_J = 1 TO si_C2 
       IF si_A(si_M3,si_J) < si_P THEN 
         si_S = si_J
         si_P = si_A(si_M3,si_J)
       END IF
     NEXT si_J
       IF si_P = - 0.00001 THEN EXIT DO
     CALL  leave(si_M, si_A(), @si_Q, @si_R, si_S)       
     CALL BoundCheck (si_Q)
  LOOP         
           FOR si_I1 =1 TO si_M
                IF si_B(si_I1) > si_C2 THEN 
                        IF si_A(si_I1,si_C1)  > 0.00001 THEN 
                            PRINT
                            PRINT " The problem has no feasible solution ! "
                            GOTO 1670
                        END IF
                    FOR si_J1 = 1 TO si_C2
            
                             IF ABS( si_A(si_I1,si_J1) ) > 0.00001 THEN 
                                      si_R = si_I1
                                     si_S = si_J1
                                  CALL pivot (si_A() , si_B() ,@si_M2, @si_R,@si_S,@si_C1,@si_P)  '
                                 si_J1 = si_C2
                             END IF
                     NEXT si_J1
                 END IF            
          NEXT si_I1
END IF         
 si_M3 = si_M2 
DO 
si_P = -0.00001
 FOR si_J = 1 TO si_C2 
  IF si_A(si_M3,si_J) < si_P THEN 
     si_S = si_J
   si_P = si_A(si_M3,si_J)
   END IF
 NEXT si_J
IF si_P = - 0.00001 THEN EXIT DO
    CALL  leave(si_M, si_A(), @si_Q, @si_R, si_S)       
    CALL BoundCheck (si_Q)
LOOP 
'-----------------------------
CALL answers(si_C1,si_C2,si_M,si_B() ,si_A() ,si_L,si_Z)
1670 input ende$
END SUB
Function Rund(x AS DOUBLE) AS DOUBLE
  Rund = INT(x * 10000000 + .5) / 10000000
End Function
'==========================SUBROUTINES===================================
SUB ParamInput (si_Z,si_M,si_N,si_L,si_E,si_G)
    si_M = SiMatrx(1,1)
    si_N = SiMatrx(1,2)
    si_L = SiMatrx(1,3)
    si_E = SiMatrx(1,4)
    si_G = SiMatrx(1,5)
    si_Z = SiMatrx(6,6) 
    si_Z = -si_Z
END SUB
'------------------------------------leave-------------------------------
SUB leave (si_M, si_A() AS DOUBLE, si_Q, si_R, si_S)
si_Q = 10 ^ 38
    FOR si_I = 1 TO si_M
        IF si_A(si_I,si_S) > 0.0001 THEN 
            IF si_A(si_I,si_C1) / si_A(si_I,si_S) < si_Q THEN 
                si_R = si_I
                si_Q = si_A(si_I,si_C1)/ si_A(si_I,si_S)
            END IF
        END IF
    NEXT si_I
END SUB
'--------------------------------------PIVOT----------------------------
SUB pivot (si_A() AS DOUBLE, si_B() AS DOUBLE, si_M2, si_R,si_S,si_C1,si_P)        
    si_P = si_A(si_R,si_S)
        FOR si_I = 1 TO si_M2 
            IF si_I <> si_R THEN 
                FOR si_J = 1 TO si_C1
                    IF si_J <> si_S THEN 
                        si_A(si_I,si_J) = si_A(si_I,si_J) - si_A(si_I,si_S) * si_A(si_R,si_J) / si_P
                            IF ABS(si_A(si_I,si_J) ) <= 0.00001 THEN  si_A(si_I,si_J) = 0                                     
                     END IF                    
                NEXT si_J 
            END IF     
        NEXT si_I
        FOR si_J = 1 TO si_C1
            si_A(si_R,si_J) = si_A(si_R,si_J) / si_P
        NEXT si_J
        FOR si_I = 1 TO si_M2
            si_A(si_I,si_S) = 0
        NEXT si_I
    si_A(si_R,si_S) = 1
    si_B(si_R) = si_S      
END SUB 
'----------------------------------------answers-------------------------------------
SUB answers (si_C1,si_C2,si_M,si_B() AS DOUBLE,si_A() AS DOUBLE,si_L,si_Z)
 COLOR 5,3   
    PRINT 
    PRINT "ANSWERS: "
    PRINT "Primal variables: "
    PRINT " variables ", "      value "                                
    FOR si_J=1 TO si_C2
        FOR si_I=1 TO si_M
           IF si_B(si_I)  = si_J THEN
                PRINT "   ",si_J,"          ", Rund(si_A(si_I,si_C1))
                si_I = si_M
           END IF     
        NEXT si_I
    NEXT si_J
    IF si_L <> 0 THEN 
        PRINT "dual variables: "
        PRINT " variable ","      value "
            FOR si_I = 1 TO si_L
                PRINT "  ",si_I, "          ",Rund(-si_Z * si_A(si_M2, si_N + si_I))
            NEXT si_I
    END IF
    PRINT
    PRINT "value of the objective function : "; Rund(-si_Z * si_A(si_M2, si_C1))
END SUB
'-----------------------------------BOUNDCHECK------------------------
SUB BoundCheck (si_Q)  
    IF  si_Q =  10 ^ 38 THEN                           
        PRINT "BoundCheck: The solution is unbounded."
    ELSE
        CALL pivot (si_A() , si_B() ,@si_M2, @si_R,@si_S,@si_C1,@si_P)   '
    END IF
END SUB
'------------------------initialization------------------------------------
SUB Initialization(si_C,si_C1,si_C2,si_M1,si_M2,si_A() AS DOUBLE, si_B() AS DOUBLE)
    si_C = si_N + si_M + si_G
    si_C1 = si_C + 1 
    si_C2 = si_N + si_L + si_G 
    si_M1 = si_M + 1 
    si_M2 = si_M + 2
        FOR si_I = 1 TO si_M2
            FOR si_J = 1 TO si_C1
                si_A(si_I,si_J) = 0
            NEXT si_J
        NEXT si_I 
        FOR si_I = 1 TO si_M
            si_B(si_I) = 0
        NEXT si_I
END SUB

   
   
   
   
   
   
   
   
   
   
